Blame


1 8e7bd50a 2019-08-22 stsp #!/bin/sh
2 8e7bd50a 2019-08-22 stsp #
3 8e7bd50a 2019-08-22 stsp # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 8e7bd50a 2019-08-22 stsp #
5 8e7bd50a 2019-08-22 stsp # Permission to use, copy, modify, and distribute this software for any
6 8e7bd50a 2019-08-22 stsp # purpose with or without fee is hereby granted, provided that the above
7 8e7bd50a 2019-08-22 stsp # copyright notice and this permission notice appear in all copies.
8 8e7bd50a 2019-08-22 stsp #
9 8e7bd50a 2019-08-22 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 8e7bd50a 2019-08-22 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 8e7bd50a 2019-08-22 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 8e7bd50a 2019-08-22 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 8e7bd50a 2019-08-22 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 8e7bd50a 2019-08-22 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 8e7bd50a 2019-08-22 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 8e7bd50a 2019-08-22 stsp
17 8e7bd50a 2019-08-22 stsp . ./common.sh
18 8e7bd50a 2019-08-22 stsp
19 f6cae3ed 2020-09-13 naddy test_tag_create() {
20 8e7bd50a 2019-08-22 stsp local testroot=`test_init tag_create`
21 8e7bd50a 2019-08-22 stsp local commit_id=`git_show_head $testroot/repo`
22 8e7bd50a 2019-08-22 stsp local tag=1.0.0
23 8e7bd50a 2019-08-22 stsp local tag2=2.0.0
24 8e7bd50a 2019-08-22 stsp
25 8e7bd50a 2019-08-22 stsp # Create a tag based on repository's HEAD reference
26 80106605 2020-02-24 stsp got tag -m 'test' -r $testroot/repo -c HEAD $tag > $testroot/stdout
27 fc414659 2022-04-16 thomas ret=$?
28 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
29 8e7bd50a 2019-08-22 stsp echo "got ref command failed unexpectedly"
30 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
31 8e7bd50a 2019-08-22 stsp return 1
32 8e7bd50a 2019-08-22 stsp fi
33 8e7bd50a 2019-08-22 stsp
34 8e7bd50a 2019-08-22 stsp tag_id=`got ref -r $testroot/repo -l \
35 8e7bd50a 2019-08-22 stsp | grep "^refs/tags/$tag" | tr -d ' ' | cut -d: -f2`
36 8e7bd50a 2019-08-22 stsp echo "Created tag $tag_id" > $testroot/stdout.expected
37 8e7bd50a 2019-08-22 stsp cmp -s $testroot/stdout $testroot/stdout.expected
38 fc414659 2022-04-16 thomas ret=$?
39 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
40 8e7bd50a 2019-08-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
41 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
42 8e7bd50a 2019-08-22 stsp return 1
43 8e7bd50a 2019-08-22 stsp fi
44 8e7bd50a 2019-08-22 stsp
45 8e7bd50a 2019-08-22 stsp # Ensure that Git recognizes the tag Got has created
46 d1e03b8c 2023-10-08 thomas git -C $testroot/repo checkout -q $tag
47 fc414659 2022-04-16 thomas ret=$?
48 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
49 8e7bd50a 2019-08-22 stsp echo "git checkout command failed unexpectedly"
50 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
51 8e7bd50a 2019-08-22 stsp return 1
52 8e7bd50a 2019-08-22 stsp fi
53 8e7bd50a 2019-08-22 stsp
54 8e7bd50a 2019-08-22 stsp # Ensure Got recognizes the new tag
55 8e7bd50a 2019-08-22 stsp got checkout -c $tag $testroot/repo $testroot/wt >/dev/null
56 fc414659 2022-04-16 thomas ret=$?
57 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
58 8e7bd50a 2019-08-22 stsp echo "got checkout command failed unexpectedly"
59 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
60 8e7bd50a 2019-08-22 stsp return 1
61 8e7bd50a 2019-08-22 stsp fi
62 8e7bd50a 2019-08-22 stsp
63 8e7bd50a 2019-08-22 stsp # Create a tag based on implied worktree HEAD ref
64 9f6b5e1c 2022-08-06 thomas (cd $testroot/wt && got branch foo > /dev/null)
65 9f6b5e1c 2022-08-06 thomas echo 'foo' >> $testroot/wt/alpha
66 9f6b5e1c 2022-08-06 thomas (cd $testroot/wt && got commit -m foo > /dev/null)
67 9f6b5e1c 2022-08-06 thomas local commit_id2=`git_show_branch_head $testroot/repo foo`
68 8e7bd50a 2019-08-22 stsp (cd $testroot/wt && got tag -m 'test' $tag2 > $testroot/stdout)
69 fc414659 2022-04-16 thomas ret=$?
70 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
71 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
72 8e7bd50a 2019-08-22 stsp return 1
73 8e7bd50a 2019-08-22 stsp fi
74 8e7bd50a 2019-08-22 stsp
75 8e7bd50a 2019-08-22 stsp tag_id2=`got ref -r $testroot/repo -l \
76 8e7bd50a 2019-08-22 stsp | grep "^refs/tags/$tag2" | tr -d ' ' | cut -d: -f2`
77 8e7bd50a 2019-08-22 stsp echo "Created tag $tag_id2" > $testroot/stdout.expected
78 8e7bd50a 2019-08-22 stsp cmp -s $testroot/stdout $testroot/stdout.expected
79 fc414659 2022-04-16 thomas ret=$?
80 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
81 8e7bd50a 2019-08-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
82 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
83 8e7bd50a 2019-08-22 stsp return 1
84 8e7bd50a 2019-08-22 stsp fi
85 8e7bd50a 2019-08-22 stsp
86 9f6b5e1c 2022-08-06 thomas tagged_commit=`got cat -r $testroot/repo $tag2 | grep ^object \
87 9f6b5e1c 2022-08-06 thomas | cut -d' ' -f2`
88 9f6b5e1c 2022-08-06 thomas if [ "$tagged_commit" != "$commit_id2" ]; then
89 9f6b5e1c 2022-08-06 thomas echo "wrong commit was tagged" >&2
90 9f6b5e1c 2022-08-06 thomas test_done "$testroot" "1"
91 9f6b5e1c 2022-08-06 thomas return 1
92 9f6b5e1c 2022-08-06 thomas fi
93 9f6b5e1c 2022-08-06 thomas
94 d1e03b8c 2023-10-08 thomas git -C $testroot/repo checkout -q $tag2
95 fc414659 2022-04-16 thomas ret=$?
96 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
97 8e7bd50a 2019-08-22 stsp echo "git checkout command failed unexpectedly"
98 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
99 a9662115 2021-08-29 naddy return 1
100 8e7bd50a 2019-08-22 stsp fi
101 8e7bd50a 2019-08-22 stsp
102 8e7bd50a 2019-08-22 stsp # Attempt to create a tag pointing at a non-commit
103 8e7bd50a 2019-08-22 stsp local tree_id=`git_show_tree $testroot/repo`
104 80106605 2020-02-24 stsp (cd $testroot/wt && got tag -m 'test' -c $tree_id foobar \
105 8e7bd50a 2019-08-22 stsp 2> $testroot/stderr)
106 fc414659 2022-04-16 thomas ret=$?
107 fc414659 2022-04-16 thomas if [ $ret -eq 0 ]; then
108 9f6b5e1c 2022-08-06 thomas echo "got tag command succeeded unexpectedly"
109 8e7bd50a 2019-08-22 stsp test_done "$testroot" "1"
110 8e7bd50a 2019-08-22 stsp return 1
111 8e7bd50a 2019-08-22 stsp fi
112 8e7bd50a 2019-08-22 stsp
113 a3599220 2021-10-10 thomas echo "got: commit $tree_id: object not found" \
114 a3599220 2021-10-10 thomas > $testroot/stderr.expected
115 8e7bd50a 2019-08-22 stsp cmp -s $testroot/stderr $testroot/stderr.expected
116 fc414659 2022-04-16 thomas ret=$?
117 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
118 8e7bd50a 2019-08-22 stsp diff -u $testroot/stderr.expected $testroot/stderr
119 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
120 8e7bd50a 2019-08-22 stsp return 1
121 8e7bd50a 2019-08-22 stsp fi
122 8e7bd50a 2019-08-22 stsp
123 8e7bd50a 2019-08-22 stsp got ref -r $testroot/repo -l > $testroot/stdout
124 9f6b5e1c 2022-08-06 thomas echo "HEAD: $commit_id2" > $testroot/stdout.expected
125 8e7bd50a 2019-08-22 stsp echo -n "refs/got/worktree/base-" >> $testroot/stdout.expected
126 8e7bd50a 2019-08-22 stsp cat $testroot/wt/.got/uuid | tr -d '\n' >> $testroot/stdout.expected
127 9f6b5e1c 2022-08-06 thomas echo ": $commit_id2" >> $testroot/stdout.expected
128 9f6b5e1c 2022-08-06 thomas echo "refs/heads/foo: $commit_id2" >> $testroot/stdout.expected
129 8e7bd50a 2019-08-22 stsp echo "refs/heads/master: $commit_id" >> $testroot/stdout.expected
130 8e7bd50a 2019-08-22 stsp echo "refs/tags/$tag: $tag_id" >> $testroot/stdout.expected
131 8e7bd50a 2019-08-22 stsp echo "refs/tags/$tag2: $tag_id2" >> $testroot/stdout.expected
132 8e7bd50a 2019-08-22 stsp cmp -s $testroot/stdout $testroot/stdout.expected
133 fc414659 2022-04-16 thomas ret=$?
134 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
135 8e7bd50a 2019-08-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
136 8e7bd50a 2019-08-22 stsp fi
137 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
138 8e7bd50a 2019-08-22 stsp }
139 8e7bd50a 2019-08-22 stsp
140 f6cae3ed 2020-09-13 naddy test_tag_list() {
141 8e7bd50a 2019-08-22 stsp local testroot=`test_init tag_list`
142 8e7bd50a 2019-08-22 stsp local commit_id=`git_show_head $testroot/repo`
143 8e7bd50a 2019-08-22 stsp local tag=1.0.0
144 8e7bd50a 2019-08-22 stsp local tag2=2.0.0
145 8e7bd50a 2019-08-22 stsp
146 e8039a4a 2019-08-23 stsp # create tag with Git
147 d1e03b8c 2023-10-08 thomas git -C $testroot/repo tag -a -m 'test' $tag
148 e8039a4a 2019-08-23 stsp # create tag with Got
149 e8039a4a 2019-08-23 stsp (cd $testroot/repo && got tag -m 'test' $tag2 > /dev/null)
150 8e7bd50a 2019-08-22 stsp
151 8e7bd50a 2019-08-22 stsp tag_id=`got ref -r $testroot/repo -l \
152 8e7bd50a 2019-08-22 stsp | grep "^refs/tags/$tag" | tr -d ' ' | cut -d: -f2`
153 8e7bd50a 2019-08-22 stsp local tagger_time=`git_show_tagger_time $testroot/repo $tag`
154 1c72bab5 2023-03-03 thomas d1=`date -u -r $tagger_time +"%a %b %e %X %Y UTC"`
155 8e7bd50a 2019-08-22 stsp tag_id2=`got ref -r $testroot/repo -l \
156 8e7bd50a 2019-08-22 stsp | grep "^refs/tags/$tag2" | tr -d ' ' | cut -d: -f2`
157 8e7bd50a 2019-08-22 stsp local tagger_time2=`git_show_tagger_time $testroot/repo $tag2`
158 1c72bab5 2023-03-03 thomas d2=`date -u -r $tagger_time2 +"%a %b %e %X %Y UTC"`
159 8e7bd50a 2019-08-22 stsp
160 8e7bd50a 2019-08-22 stsp got tag -r $testroot/repo -l > $testroot/stdout
161 8e7bd50a 2019-08-22 stsp
162 8e7bd50a 2019-08-22 stsp echo "-----------------------------------------------" \
163 8e7bd50a 2019-08-22 stsp > $testroot/stdout.expected
164 b8bad2ba 2019-08-23 stsp echo "tag $tag2 $tag_id2" >> $testroot/stdout.expected
165 8e7bd50a 2019-08-22 stsp echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
166 ac03cf6d 2020-01-17 stsp echo "date: $d2" >> $testroot/stdout.expected
167 2417344c 2019-08-23 stsp echo "object: commit $commit_id" >> $testroot/stdout.expected
168 8e7bd50a 2019-08-22 stsp echo " " >> $testroot/stdout.expected
169 8e7bd50a 2019-08-22 stsp echo " test" >> $testroot/stdout.expected
170 8e7bd50a 2019-08-22 stsp echo " " >> $testroot/stdout.expected
171 8e7bd50a 2019-08-22 stsp echo "-----------------------------------------------" \
172 8e7bd50a 2019-08-22 stsp >> $testroot/stdout.expected
173 68e8cedb 2022-07-01 thomas echo "tag $tag $tag_id" >> $testroot/stdout.expected
174 68e8cedb 2022-07-01 thomas echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
175 68e8cedb 2022-07-01 thomas echo "date: $d1" >> $testroot/stdout.expected
176 68e8cedb 2022-07-01 thomas echo "object: commit $commit_id" >> $testroot/stdout.expected
177 68e8cedb 2022-07-01 thomas echo " " >> $testroot/stdout.expected
178 68e8cedb 2022-07-01 thomas echo " test" >> $testroot/stdout.expected
179 68e8cedb 2022-07-01 thomas echo " " >> $testroot/stdout.expected
180 68e8cedb 2022-07-01 thomas cmp -s $testroot/stdout $testroot/stdout.expected
181 68e8cedb 2022-07-01 thomas ret=$?
182 68e8cedb 2022-07-01 thomas if [ $ret -ne 0 ]; then
183 68e8cedb 2022-07-01 thomas diff -u $testroot/stdout.expected $testroot/stdout
184 68e8cedb 2022-07-01 thomas test_done "$testroot" "$ret"
185 68e8cedb 2022-07-01 thomas return 1
186 68e8cedb 2022-07-01 thomas fi
187 68e8cedb 2022-07-01 thomas
188 68e8cedb 2022-07-01 thomas got tag -r $testroot/repo -l $tag > $testroot/stdout
189 68e8cedb 2022-07-01 thomas
190 68e8cedb 2022-07-01 thomas echo "-----------------------------------------------" \
191 68e8cedb 2022-07-01 thomas > $testroot/stdout.expected
192 b8bad2ba 2019-08-23 stsp echo "tag $tag $tag_id" >> $testroot/stdout.expected
193 8e7bd50a 2019-08-22 stsp echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
194 ac03cf6d 2020-01-17 stsp echo "date: $d1" >> $testroot/stdout.expected
195 2417344c 2019-08-23 stsp echo "object: commit $commit_id" >> $testroot/stdout.expected
196 8e7bd50a 2019-08-22 stsp echo " " >> $testroot/stdout.expected
197 8e7bd50a 2019-08-22 stsp echo " test" >> $testroot/stdout.expected
198 8e7bd50a 2019-08-22 stsp echo " " >> $testroot/stdout.expected
199 8e7bd50a 2019-08-22 stsp cmp -s $testroot/stdout $testroot/stdout.expected
200 fc414659 2022-04-16 thomas ret=$?
201 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
202 8e7bd50a 2019-08-22 stsp diff -u $testroot/stdout.expected $testroot/stdout
203 68e8cedb 2022-07-01 thomas test_done "$testroot" "$ret"
204 68e8cedb 2022-07-01 thomas return 1
205 8e7bd50a 2019-08-22 stsp fi
206 68e8cedb 2022-07-01 thomas
207 68e8cedb 2022-07-01 thomas got tag -r $testroot/repo -l $tag2 > $testroot/stdout
208 68e8cedb 2022-07-01 thomas
209 68e8cedb 2022-07-01 thomas echo "-----------------------------------------------" \
210 68e8cedb 2022-07-01 thomas > $testroot/stdout.expected
211 68e8cedb 2022-07-01 thomas echo "tag $tag2 $tag_id2" >> $testroot/stdout.expected
212 68e8cedb 2022-07-01 thomas echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
213 68e8cedb 2022-07-01 thomas echo "date: $d2" >> $testroot/stdout.expected
214 68e8cedb 2022-07-01 thomas echo "object: commit $commit_id" >> $testroot/stdout.expected
215 68e8cedb 2022-07-01 thomas echo " " >> $testroot/stdout.expected
216 68e8cedb 2022-07-01 thomas echo " test" >> $testroot/stdout.expected
217 68e8cedb 2022-07-01 thomas echo " " >> $testroot/stdout.expected
218 68e8cedb 2022-07-01 thomas cmp -s $testroot/stdout $testroot/stdout.expected
219 68e8cedb 2022-07-01 thomas ret=$?
220 68e8cedb 2022-07-01 thomas if [ $ret -ne 0 ]; then
221 68e8cedb 2022-07-01 thomas diff -u $testroot/stdout.expected $testroot/stdout
222 68e8cedb 2022-07-01 thomas fi
223 8e7bd50a 2019-08-22 stsp test_done "$testroot" "$ret"
224 8e7bd50a 2019-08-22 stsp }
225 8e7bd50a 2019-08-22 stsp
226 f6cae3ed 2020-09-13 naddy test_tag_list_lightweight() {
227 d4efa91b 2020-01-14 stsp local testroot=`test_init tag_list_lightweight`
228 d4efa91b 2020-01-14 stsp local commit_id=`git_show_head $testroot/repo`
229 d4efa91b 2020-01-14 stsp local tag=1.0.0
230 d4efa91b 2020-01-14 stsp local tag2=2.0.0
231 d4efa91b 2020-01-14 stsp
232 d4efa91b 2020-01-14 stsp # create "lightweight" tag with Git
233 d1e03b8c 2023-10-08 thomas git -C $testroot/repo tag $tag
234 d1e03b8c 2023-10-08 thomas git -C $testroot/repo tag $tag2
235 d4efa91b 2020-01-14 stsp
236 d4efa91b 2020-01-14 stsp tag_id=`got ref -r $testroot/repo -l \
237 d4efa91b 2020-01-14 stsp | grep "^refs/tags/$tag" | tr -d ' ' | cut -d: -f2`
238 d4efa91b 2020-01-14 stsp local tagger_time=`git_show_author_time $testroot/repo $tag`
239 1c72bab5 2023-03-03 thomas d1=`date -u -r $tagger_time +"%a %b %e %X %Y UTC"`
240 d4efa91b 2020-01-14 stsp tag_id2=`got ref -r $testroot/repo -l \
241 d4efa91b 2020-01-14 stsp | grep "^refs/tags/$tag2" | tr -d ' ' | cut -d: -f2`
242 d4efa91b 2020-01-14 stsp local tagger_time2=`git_show_author_time $testroot/repo $tag2`
243 1c72bab5 2023-03-03 thomas d2=`date -u -r $tagger_time2 +"%a %b %e %X %Y UTC"`
244 d4efa91b 2020-01-14 stsp
245 d4efa91b 2020-01-14 stsp got tag -r $testroot/repo -l > $testroot/stdout
246 d4efa91b 2020-01-14 stsp
247 06714b03 2022-09-02 thomas # test signature validation ignoring lightweight tags
248 06714b03 2022-09-02 thomas got tag -r $testroot/repo -V > $testroot/stdout
249 06714b03 2022-09-02 thomas
250 d4efa91b 2020-01-14 stsp echo "-----------------------------------------------" \
251 d4efa91b 2020-01-14 stsp > $testroot/stdout.expected
252 d4efa91b 2020-01-14 stsp echo "tag $tag2 $tag_id2" >> $testroot/stdout.expected
253 d4efa91b 2020-01-14 stsp echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
254 ac03cf6d 2020-01-17 stsp echo "date: $d2" >> $testroot/stdout.expected
255 d4efa91b 2020-01-14 stsp echo "object: commit $commit_id" >> $testroot/stdout.expected
256 d4efa91b 2020-01-14 stsp echo " " >> $testroot/stdout.expected
257 d4efa91b 2020-01-14 stsp echo " adding the test tree" >> $testroot/stdout.expected
258 d4efa91b 2020-01-14 stsp echo " " >> $testroot/stdout.expected
259 d4efa91b 2020-01-14 stsp echo "-----------------------------------------------" \
260 d4efa91b 2020-01-14 stsp >> $testroot/stdout.expected
261 d4efa91b 2020-01-14 stsp echo "tag $tag $tag_id" >> $testroot/stdout.expected
262 d4efa91b 2020-01-14 stsp echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
263 ac03cf6d 2020-01-17 stsp echo "date: $d1" >> $testroot/stdout.expected
264 d4efa91b 2020-01-14 stsp echo "object: commit $commit_id" >> $testroot/stdout.expected
265 d4efa91b 2020-01-14 stsp echo " " >> $testroot/stdout.expected
266 d4efa91b 2020-01-14 stsp echo " adding the test tree" >> $testroot/stdout.expected
267 d4efa91b 2020-01-14 stsp echo " " >> $testroot/stdout.expected
268 d4efa91b 2020-01-14 stsp cmp -s $testroot/stdout $testroot/stdout.expected
269 fc414659 2022-04-16 thomas ret=$?
270 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
271 d4efa91b 2020-01-14 stsp diff -u $testroot/stdout.expected $testroot/stdout
272 d4efa91b 2020-01-14 stsp fi
273 d4efa91b 2020-01-14 stsp test_done "$testroot" "$ret"
274 d4efa91b 2020-01-14 stsp }
275 871bd038 2022-07-03 thomas
276 871bd038 2022-07-03 thomas test_tag_create_ssh_signed() {
277 871bd038 2022-07-03 thomas local testroot=`test_init tag_create`
278 871bd038 2022-07-03 thomas local commit_id=`git_show_head $testroot/repo`
279 871bd038 2022-07-03 thomas local tag=1.0.0
280 871bd038 2022-07-03 thomas local tag2=2.0.0
281 ff5e1f09 2022-07-06 thomas local tag3=3.0.0
282 871bd038 2022-07-03 thomas
283 871bd038 2022-07-03 thomas ssh-keygen -q -N '' -t ed25519 -f $testroot/id_ed25519
284 871bd038 2022-07-03 thomas ret=$?
285 871bd038 2022-07-03 thomas if [ $ret -ne 0 ]; then
286 871bd038 2022-07-03 thomas echo "ssh-keygen failed unexpectedly"
287 871bd038 2022-07-03 thomas test_done "$testroot" "$ret"
288 871bd038 2022-07-03 thomas return 1
289 871bd038 2022-07-03 thomas fi
290 871bd038 2022-07-03 thomas touch $testroot/allowed_signers
291 c0805ce5 2022-07-04 thomas touch $testroot/revoked_signers
292 c0805ce5 2022-07-04 thomas echo "allowed_signers \"$testroot/allowed_signers\"" >> \
293 c0805ce5 2022-07-04 thomas $testroot/repo/.git/got.conf
294 c0805ce5 2022-07-04 thomas echo "revoked_signers \"$testroot/revoked_signers\"" >> \
295 871bd038 2022-07-03 thomas $testroot/repo/.git/got.conf
296 871bd038 2022-07-03 thomas
297 871bd038 2022-07-03 thomas # Create a signed tag based on repository's HEAD reference
298 871bd038 2022-07-03 thomas got tag -s $testroot/id_ed25519 -m 'test' -r $testroot/repo -c HEAD \
299 871bd038 2022-07-03 thomas $tag > $testroot/stdout
300 871bd038 2022-07-03 thomas ret=$?
301 871bd038 2022-07-03 thomas if [ $ret -ne 0 ]; then
302 871bd038 2022-07-03 thomas echo "got tag command failed unexpectedly"
303 871bd038 2022-07-03 thomas test_done "$testroot" "$ret"
304 871bd038 2022-07-03 thomas return 1
305 871bd038 2022-07-03 thomas fi
306 871bd038 2022-07-03 thomas
307 871bd038 2022-07-03 thomas tag_id=`got ref -r $testroot/repo -l \
308 871bd038 2022-07-03 thomas | grep "^refs/tags/$tag" | tr -d ' ' | cut -d: -f2`
309 871bd038 2022-07-03 thomas echo "Created tag $tag_id" > $testroot/stdout.expected
310 871bd038 2022-07-03 thomas cmp -s $testroot/stdout $testroot/stdout.expected
311 871bd038 2022-07-03 thomas ret=$?
312 871bd038 2022-07-03 thomas if [ $ret -ne 0 ]; then
313 871bd038 2022-07-03 thomas diff -u $testroot/stdout.expected $testroot/stdout
314 871bd038 2022-07-03 thomas test_done "$testroot" "$ret"
315 871bd038 2022-07-03 thomas return 1
316 871bd038 2022-07-03 thomas fi
317 871bd038 2022-07-03 thomas
318 871bd038 2022-07-03 thomas # Ensure validation fails when the key is not allowed
319 871bd038 2022-07-03 thomas echo "signature: Could not verify signature." > \
320 871bd038 2022-07-03 thomas $testroot/stdout.expected
321 871bd038 2022-07-03 thomas VERIFY_STDOUT=$(got tag -r $testroot/repo -V $tag 2> $testroot/stderr)
322 871bd038 2022-07-03 thomas ret=$?
323 871bd038 2022-07-03 thomas echo "$VERIFY_STDOUT" | grep '^signature: ' > $testroot/stdout
324 871bd038 2022-07-03 thomas if [ $ret -eq 0 ]; then
325 871bd038 2022-07-03 thomas diff -u $testroot/stdout.expected $testroot/stdout
326 871bd038 2022-07-03 thomas test_done "$testroot" "1"
327 871bd038 2022-07-03 thomas return 1
328 871bd038 2022-07-03 thomas fi
329 d4efa91b 2020-01-14 stsp
330 ebc58f12 2022-07-04 thomas GOOD_SIG='Good "git" signature for flan_hacker@openbsd.org with ED25519 key '
331 871bd038 2022-07-03 thomas
332 871bd038 2022-07-03 thomas # Validate the signature with the key allowed
333 871bd038 2022-07-03 thomas echo -n 'flan_hacker@openbsd.org ' > $testroot/allowed_signers
334 871bd038 2022-07-03 thomas cat $testroot/id_ed25519.pub >> $testroot/allowed_signers
335 871bd038 2022-07-03 thomas GOT_STDOUT=$(got tag -r $testroot/repo -V $tag 2> $testroot/stderr)
336 871bd038 2022-07-03 thomas ret=$?
337 871bd038 2022-07-03 thomas if [ $ret -ne 0 ]; then
338 871bd038 2022-07-03 thomas echo "got tag command failed unexpectedly"
339 871bd038 2022-07-03 thomas diff -u $testroot/stdout.expected $testroot/stdout
340 871bd038 2022-07-03 thomas test_done "$testroot" "$ret"
341 ebc58f12 2022-07-04 thomas return 1
342 ebc58f12 2022-07-04 thomas fi
343 ebc58f12 2022-07-04 thomas
344 ebc58f12 2022-07-04 thomas if ! echo "$GOT_STDOUT" | grep -q "^signature: $GOOD_SIG"; then
345 ebc58f12 2022-07-04 thomas echo "got tag command failed to validate signature"
346 ebc58f12 2022-07-04 thomas test_done "$testroot" "1"
347 871bd038 2022-07-03 thomas return 1
348 871bd038 2022-07-03 thomas fi
349 871bd038 2022-07-03 thomas
350 c0805ce5 2022-07-04 thomas # Ensure validation fails after revoking the key
351 c0805ce5 2022-07-04 thomas ssh-keygen -y -f $testroot/id_ed25519 >> $testroot/revoked_signers
352 c0805ce5 2022-07-04 thomas echo "signature: Could not verify signature." > \
353 c0805ce5 2022-07-04 thomas $testroot/stdout.expected
354 c0805ce5 2022-07-04 thomas VERIFY_STDOUT=$(got tag -r $testroot/repo -V $tag 2> $testroot/stderr)
355 c0805ce5 2022-07-04 thomas ret=$?
356 c0805ce5 2022-07-04 thomas echo "$VERIFY_STDOUT" | grep '^signature: ' > $testroot/stdout
357 c0805ce5 2022-07-04 thomas if [ $ret -eq 0 ]; then
358 c0805ce5 2022-07-04 thomas diff -u $testroot/stdout.expected $testroot/stdout
359 c0805ce5 2022-07-04 thomas test_done "$testroot" "1"
360 c0805ce5 2022-07-04 thomas return 1
361 c0805ce5 2022-07-04 thomas fi
362 c0805ce5 2022-07-04 thomas
363 c0805ce5 2022-07-04 thomas # Later tests expect validation to work
364 c0805ce5 2022-07-04 thomas echo -n > $testroot/revoked_signers
365 c0805ce5 2022-07-04 thomas
366 ebc58f12 2022-07-04 thomas # Ensure that Git recognizes and verifies the tag Got has created
367 d1e03b8c 2023-10-08 thomas git -C $testroot/repo checkout -q $tag
368 ebc58f12 2022-07-04 thomas ret=$?
369 ebc58f12 2022-07-04 thomas if [ $ret -ne 0 ]; then
370 ebc58f12 2022-07-04 thomas echo "git checkout command failed unexpectedly"
371 ebc58f12 2022-07-04 thomas test_done "$testroot" "$ret"
372 ebc58f12 2022-07-04 thomas return 1
373 ebc58f12 2022-07-04 thomas fi
374 d1e03b8c 2023-10-08 thomas git -C $testroot/repo config --local gpg.ssh.allowedSignersFile \
375 d1e03b8c 2023-10-08 thomas $testroot/allowed_signers
376 d1e03b8c 2023-10-08 thomas GIT_STDERR=$(git -C $testroot/repo tag -v $tag 2>&1 1>/dev/null)
377 ebc58f12 2022-07-04 thomas if ! echo "$GIT_STDERR" | grep -q "^$GOOD_SIG"; then
378 ebc58f12 2022-07-04 thomas echo "git tag command failed to validate signature"
379 ebc58f12 2022-07-04 thomas test_done "$testroot" "1"
380 ebc58f12 2022-07-04 thomas return 1
381 ebc58f12 2022-07-04 thomas fi
382 ebc58f12 2022-07-04 thomas
383 ebc58f12 2022-07-04 thomas # Ensure Got recognizes the new tag
384 ebc58f12 2022-07-04 thomas got checkout -c $tag $testroot/repo $testroot/wt >/dev/null
385 ebc58f12 2022-07-04 thomas ret=$?
386 ebc58f12 2022-07-04 thomas if [ $ret -ne 0 ]; then
387 ebc58f12 2022-07-04 thomas echo "got checkout command failed unexpectedly"
388 ff5e1f09 2022-07-06 thomas test_done "$testroot" "$ret"
389 ff5e1f09 2022-07-06 thomas return 1
390 ff5e1f09 2022-07-06 thomas fi
391 ff5e1f09 2022-07-06 thomas
392 ff5e1f09 2022-07-06 thomas # Create another signed tag with a SHA1 commit ID
393 ff5e1f09 2022-07-06 thomas got tag -s $testroot/id_ed25519 -m 'test' -r $testroot/repo \
394 ff5e1f09 2022-07-06 thomas -c $commit_id $tag2 > $testroot/stdout
395 ff5e1f09 2022-07-06 thomas
396 ff5e1f09 2022-07-06 thomas # Create another signed tag with key defined in got.conf(5)
397 ff5e1f09 2022-07-06 thomas echo "signer_id \"$testroot/id_ed25519\"" >> \
398 ff5e1f09 2022-07-06 thomas $testroot/repo/.git/got.conf
399 ff5e1f09 2022-07-06 thomas got tag -m 'test' -r $testroot/repo -c HEAD $tag3 > $testroot/stdout
400 ff5e1f09 2022-07-06 thomas ret=$?
401 ff5e1f09 2022-07-06 thomas if [ $ret -ne 0 ]; then
402 ff5e1f09 2022-07-06 thomas echo "got tag command failed unexpectedly"
403 ff5e1f09 2022-07-06 thomas test_done "$testroot" "$ret"
404 ff5e1f09 2022-07-06 thomas return 1
405 ebc58f12 2022-07-04 thomas fi
406 ff5e1f09 2022-07-06 thomas
407 ff5e1f09 2022-07-06 thomas # got tag -V behaves like got tag -l, but with verification enabled.
408 ff5e1f09 2022-07-06 thomas got tag -l -r $testroot/repo > $testroot/stdout.list
409 ff5e1f09 2022-07-06 thomas got tag -V -r $testroot/repo > $testroot/stdout.verify
410 ff5e1f09 2022-07-06 thomas diff -U0 $testroot/stdout.list $testroot/stdout.verify |
411 ff5e1f09 2022-07-06 thomas sed -e '/^--- /d' -e '/^+++ /d' > $testroot/stdout
412 ff5e1f09 2022-07-06 thomas echo "@@ -5,0 +6 @@" > $testroot/stdout.expected
413 ff5e1f09 2022-07-06 thomas echo -n "+signature: $GOOD_SIG" >> $testroot/stdout.expected
414 ff5e1f09 2022-07-06 thomas ssh-keygen -l -f $testroot/id_ed25519.pub | cut -d' ' -f 2 \
415 ff5e1f09 2022-07-06 thomas >> $testroot/stdout.expected
416 ff5e1f09 2022-07-06 thomas echo "@@ -19,0 +21 @@" >> $testroot/stdout.expected
417 ff5e1f09 2022-07-06 thomas echo -n "+signature: $GOOD_SIG" >> $testroot/stdout.expected
418 ff5e1f09 2022-07-06 thomas ssh-keygen -l -f $testroot/id_ed25519.pub | cut -d' ' -f 2 \
419 ff5e1f09 2022-07-06 thomas >> $testroot/stdout.expected
420 ff5e1f09 2022-07-06 thomas echo "@@ -33,0 +36 @@" >> $testroot/stdout.expected
421 ff5e1f09 2022-07-06 thomas echo -n "+signature: $GOOD_SIG" >> $testroot/stdout.expected
422 ff5e1f09 2022-07-06 thomas ssh-keygen -l -f $testroot/id_ed25519.pub | cut -d' ' -f 2 \
423 ff5e1f09 2022-07-06 thomas >> $testroot/stdout.expected
424 ff5e1f09 2022-07-06 thomas cmp -s $testroot/stdout $testroot/stdout.expected
425 ff5e1f09 2022-07-06 thomas ret=$?
426 ff5e1f09 2022-07-06 thomas if [ $ret -ne 0 ]; then
427 ff5e1f09 2022-07-06 thomas diff -u $testroot/stdout.expected $testroot/stdout
428 ff5e1f09 2022-07-06 thomas fi
429 ebc58f12 2022-07-04 thomas test_done "$testroot" "$ret"
430 ebc58f12 2022-07-04 thomas }
431 ebc58f12 2022-07-04 thomas
432 64313a9c 2022-07-03 thomas test_tag_create_ssh_signed_missing_key() {
433 64313a9c 2022-07-03 thomas local testroot=`test_init tag_create`
434 64313a9c 2022-07-03 thomas local commit_id=`git_show_head $testroot/repo`
435 64313a9c 2022-07-03 thomas local tag=1.0.0
436 64313a9c 2022-07-03 thomas
437 64313a9c 2022-07-03 thomas # Fail to create a signed tag due to a missing SSH key
438 64313a9c 2022-07-03 thomas got tag -s $testroot/bogus -m 'test' -r $testroot/repo \
439 64313a9c 2022-07-03 thomas -c HEAD $tag > $testroot/stdout 2> $testroot/stderr
440 64313a9c 2022-07-03 thomas ret=$?
441 64313a9c 2022-07-03 thomas if [ $ret -eq 0 ]; then
442 64313a9c 2022-07-03 thomas echo "got tag command succeeded unexpectedly"
443 64313a9c 2022-07-03 thomas test_done "$testroot" 1
444 64313a9c 2022-07-03 thomas return 1
445 64313a9c 2022-07-03 thomas fi
446 871bd038 2022-07-03 thomas
447 64313a9c 2022-07-03 thomas got ref -r $testroot/repo -l > $testroot/stdout
448 64313a9c 2022-07-03 thomas echo "HEAD: refs/heads/master" > $testroot/stdout.expected
449 64313a9c 2022-07-03 thomas echo "refs/heads/master: $commit_id" >> $testroot/stdout.expected
450 64313a9c 2022-07-03 thomas cmp -s $testroot/stdout $testroot/stdout.expected
451 64313a9c 2022-07-03 thomas ret=$?
452 64313a9c 2022-07-03 thomas if [ $ret -ne 0 ]; then
453 64313a9c 2022-07-03 thomas diff -u $testroot/stdout.expected $testroot/stdout
454 64313a9c 2022-07-03 thomas test_done "$testroot" "$ret"
455 64313a9c 2022-07-03 thomas return 1
456 64313a9c 2022-07-03 thomas fi
457 64313a9c 2022-07-03 thomas printf "Couldn't load public key $testroot/bogus: " \
458 492a65d9 2022-07-04 thomas >> $testroot/stderr.expected
459 64313a9c 2022-07-03 thomas printf "No such file or directory\r\n" >> $testroot/stderr.expected
460 492a65d9 2022-07-04 thomas echo "got: unable to sign tag" >> $testroot/stderr.expected
461 64313a9c 2022-07-03 thomas cmp -s $testroot/stderr $testroot/stderr.expected
462 64313a9c 2022-07-03 thomas ret=$?
463 64313a9c 2022-07-03 thomas if [ $ret -ne 0 ]; then
464 64313a9c 2022-07-03 thomas diff -u $testroot/stderr.expected $testroot/stderr
465 3795e2b6 2023-07-19 thomas fi
466 3795e2b6 2023-07-19 thomas test_done "$testroot" "$ret"
467 3795e2b6 2023-07-19 thomas }
468 3795e2b6 2023-07-19 thomas
469 3795e2b6 2023-07-19 thomas test_tag_commit_keywords() {
470 3795e2b6 2023-07-19 thomas local testroot=$(test_init tag_commit_keywords)
471 3795e2b6 2023-07-19 thomas local repo="$testroot/repo"
472 3795e2b6 2023-07-19 thomas local wt="$testroot/wt"
473 3795e2b6 2023-07-19 thomas local commit_id=$(git_show_head "$repo")
474 3795e2b6 2023-07-19 thomas local tag=1.0.0
475 3795e2b6 2023-07-19 thomas local tag2=2.0.0
476 3795e2b6 2023-07-19 thomas
477 3795e2b6 2023-07-19 thomas echo "alphas" > "$repo/alpha"
478 3795e2b6 2023-07-19 thomas git_commit "$repo" -m "alphas"
479 3795e2b6 2023-07-19 thomas
480 3795e2b6 2023-07-19 thomas # create tag based on first gen ancestor of the repository's HEAD
481 3795e2b6 2023-07-19 thomas got tag -m 'v1.0.0' -r "$repo" -c:head:- "$tag" > "$testroot/stdout"
482 3795e2b6 2023-07-19 thomas ret=$?
483 3795e2b6 2023-07-19 thomas if [ $ret -ne 0 ]; then
484 3795e2b6 2023-07-19 thomas echo "got ref command failed unexpectedly"
485 3795e2b6 2023-07-19 thomas test_done "$testroot" "$ret"
486 3795e2b6 2023-07-19 thomas return 1
487 3795e2b6 2023-07-19 thomas fi
488 3795e2b6 2023-07-19 thomas
489 3795e2b6 2023-07-19 thomas tag_id=$(got ref -r "$repo" -l \
490 3795e2b6 2023-07-19 thomas | grep "^refs/tags/$tag" | tr -d ' ' | cut -d: -f2)
491 3795e2b6 2023-07-19 thomas echo "Created tag $tag_id" > "$testroot/stdout.expected"
492 3795e2b6 2023-07-19 thomas cmp -s "$testroot/stdout" "$testroot/stdout.expected"
493 3795e2b6 2023-07-19 thomas ret=$?
494 3795e2b6 2023-07-19 thomas if [ $ret -ne 0 ]; then
495 3795e2b6 2023-07-19 thomas diff -u "$testroot/stdout.expected" "$testroot/stdout"
496 3795e2b6 2023-07-19 thomas test_done "$testroot" "$ret"
497 3795e2b6 2023-07-19 thomas return 1
498 3795e2b6 2023-07-19 thomas fi
499 3795e2b6 2023-07-19 thomas
500 3795e2b6 2023-07-19 thomas tag_commit=$(got cat -r "$repo" "$tag" | grep ^object | cut -d' ' -f2)
501 3795e2b6 2023-07-19 thomas if [ "$tag_commit" != "$commit_id" ]; then
502 3795e2b6 2023-07-19 thomas echo "wrong commit was tagged" >&2
503 3795e2b6 2023-07-19 thomas test_done "$testroot" "1"
504 3795e2b6 2023-07-19 thomas return 1
505 3795e2b6 2023-07-19 thomas fi
506 3795e2b6 2023-07-19 thomas
507 3795e2b6 2023-07-19 thomas got checkout -c "$tag" "$repo" "$wt" >/dev/null
508 3795e2b6 2023-07-19 thomas ret=$?
509 3795e2b6 2023-07-19 thomas if [ $ret -ne 0 ]; then
510 3795e2b6 2023-07-19 thomas echo "got checkout command failed unexpectedly"
511 3795e2b6 2023-07-19 thomas test_done "$testroot" "$ret"
512 3795e2b6 2023-07-19 thomas return 1
513 3795e2b6 2023-07-19 thomas fi
514 3795e2b6 2023-07-19 thomas
515 3795e2b6 2023-07-19 thomas # create new tag based on the base commit's 2nd gen descendant
516 3795e2b6 2023-07-19 thomas (cd "$wt" && got up > /dev/null)
517 3795e2b6 2023-07-19 thomas echo 'foo' > "$wt/alpha"
518 3795e2b6 2023-07-19 thomas echo 'boo' > "$wt/beta"
519 3795e2b6 2023-07-19 thomas echo 'hoo' > "$wt/gamma/delta"
520 3795e2b6 2023-07-19 thomas (cd "$wt" && got commit -m foo alpha > /dev/null)
521 3795e2b6 2023-07-19 thomas (cd "$wt" && got commit -m boo beta > /dev/null)
522 3795e2b6 2023-07-19 thomas (cd "$wt" && got commit -m hoo gamma/delta > /dev/null)
523 3795e2b6 2023-07-19 thomas local head_id=$(git_show_branch_head "$repo")
524 3795e2b6 2023-07-19 thomas (cd "$wt" && got up -c:base:-2 > /dev/null)
525 3795e2b6 2023-07-19 thomas local base_id=$(cd "$wt" && got info | grep base | cut -d' ' -f5)
526 3795e2b6 2023-07-19 thomas
527 3795e2b6 2023-07-19 thomas (cd "$wt" && got tag -m 'v2.0.0' -c:base:+2 $tag2 > "$testroot/stdout")
528 3795e2b6 2023-07-19 thomas ret=$?
529 3795e2b6 2023-07-19 thomas if [ $ret -ne 0 ]; then
530 3795e2b6 2023-07-19 thomas test_done "$testroot" "$ret"
531 3795e2b6 2023-07-19 thomas return 1
532 64313a9c 2022-07-03 thomas fi
533 3795e2b6 2023-07-19 thomas
534 3795e2b6 2023-07-19 thomas tag_id2=$(got ref -r "$repo" -l \
535 3795e2b6 2023-07-19 thomas | grep "^refs/tags/$tag2" | tr -d ' ' | cut -d: -f2)
536 3795e2b6 2023-07-19 thomas echo "Created tag $tag_id2" > $testroot/stdout.expected
537 3795e2b6 2023-07-19 thomas
538 3795e2b6 2023-07-19 thomas cmp -s $testroot/stdout $testroot/stdout.expected
539 3795e2b6 2023-07-19 thomas ret=$?
540 3795e2b6 2023-07-19 thomas if [ $ret -ne 0 ]; then
541 3795e2b6 2023-07-19 thomas diff -u $testroot/stdout.expected $testroot/stdout
542 3795e2b6 2023-07-19 thomas test_done "$testroot" "$ret"
543 3795e2b6 2023-07-19 thomas return 1
544 3795e2b6 2023-07-19 thomas fi
545 3795e2b6 2023-07-19 thomas
546 3795e2b6 2023-07-19 thomas tag2_commit=$(got cat -r "$repo" "$tag2" | grep ^object | cut -d' ' -f2)
547 3795e2b6 2023-07-19 thomas if [ "$tag2_commit" != "$head_id" ]; then
548 3795e2b6 2023-07-19 thomas echo "wrong commit was tagged" >&2
549 3795e2b6 2023-07-19 thomas test_done "$testroot" "1"
550 3795e2b6 2023-07-19 thomas return 1
551 3795e2b6 2023-07-19 thomas fi
552 3795e2b6 2023-07-19 thomas
553 3795e2b6 2023-07-19 thomas echo "HEAD: refs/heads/master" > $testroot/stdout.expected
554 3795e2b6 2023-07-19 thomas echo -n "refs/got/worktree/base-" >> $testroot/stdout.expected
555 3795e2b6 2023-07-19 thomas cat "$wt/.got/uuid" | tr -d '\n' >> $testroot/stdout.expected
556 3795e2b6 2023-07-19 thomas echo ": $base_id" >> $testroot/stdout.expected
557 3795e2b6 2023-07-19 thomas echo "refs/heads/master: $head_id" >> $testroot/stdout.expected
558 3795e2b6 2023-07-19 thomas echo "refs/tags/$tag: $tag_id" >> $testroot/stdout.expected
559 3795e2b6 2023-07-19 thomas echo "refs/tags/$tag2: $tag_id2" >> $testroot/stdout.expected
560 3795e2b6 2023-07-19 thomas
561 3795e2b6 2023-07-19 thomas got ref -r "$repo" -l > $testroot/stdout
562 3795e2b6 2023-07-19 thomas
563 3795e2b6 2023-07-19 thomas cmp -s $testroot/stdout $testroot/stdout.expected
564 3795e2b6 2023-07-19 thomas ret=$?
565 3795e2b6 2023-07-19 thomas if [ $ret -ne 0 ]; then
566 3795e2b6 2023-07-19 thomas diff -u $testroot/stdout.expected $testroot/stdout
567 3795e2b6 2023-07-19 thomas fi
568 3795e2b6 2023-07-19 thomas
569 64313a9c 2022-07-03 thomas test_done "$testroot" "$ret"
570 64313a9c 2022-07-03 thomas }
571 64313a9c 2022-07-03 thomas
572 7fb414ae 2020-08-08 stsp test_parseargs "$@"
573 8e7bd50a 2019-08-22 stsp run_test test_tag_create
574 8e7bd50a 2019-08-22 stsp run_test test_tag_list
575 d4efa91b 2020-01-14 stsp run_test test_tag_list_lightweight
576 871bd038 2022-07-03 thomas run_test test_tag_create_ssh_signed
577 492a65d9 2022-07-04 thomas run_test test_tag_create_ssh_signed_missing_key
578 3795e2b6 2023-07-19 thomas run_test test_tag_commit_keywords